package intro2java;
import robocode.*;

/**
 * Experiment with adding additional attributes that control your robots 
 * behaviour:
 * a. a boolean attribute called aggressive can indicate whether the 
 *    gun should fire at each corner
 * b. a boolean attribute called scanForRobots can control whether 
 *    the robot rotates its radar at each corner
 * c. other attributes can control the size of the square, the number of 
 *    degrees the gun and radar are turned, the direction of their turn, 
 *    etc.
 */
public class Exercise2_4 extends Robot
{
    public final static int LENGTH_OF_SQUARE = 150;
	public final static int GUN_ROTATION = 360;
	public final static int RADAR_ROTATION = 360;
	
	private int _numberOfSquares = 0;
	private boolean _clockwise = false;
	private boolean _aggresive = true;
	private boolean _scanForRobots = true;
	private int _sizeOfSquare = LENGTH_OF_SQUARE;
	private int _gunRotation = GUN_ROTATION;
	private int _radarRotation = RADAR_ROTATION;
		
	public void run() {
		while(true) {
			moveInSquare(LENGTH_OF_SQUARE);
			out.println("Moved " + _numberOfSquares + " squares");
		}
	}

	private void moveInSquare(int lengthOfSide)
	{
		for (int i=0; i < 4; i++)
		{
			ahead(lengthOfSide);
			doCorner();
		}						
		_numberOfSquares++;			
	}	
	
	private void doCorner()
	{
		if (_clockwise)
		{
			turnRight(90);
		}
		else
		{
			turnLeft(90);
		}
		turnGunRight(_gunRotation);
		if (_scanForRobots)
		{
			turnRadarRight(_radarRotation);
		}
		if (_aggresive)
		{
			fire(1);
		}
	}
}
		